<?php

/* * ****************************************************
 * CjOverkill version 5.3.1
 * � Kaloyan Olegov Georgiev
 * http://www.icefire.org/
 * spam@icefire.org
 *
 * Please read the lisence before you start editing this script.
 *
 * ****************************************************** */

@ignore_user_abort ( true );
//include ("cj-filter.php");
include ("cj-conf.inc.php");
include ("cj-functions.inc.php");
cjoverkill_connect ();

$site_dom = cjoverkill_sanityze ( $_SERVER["HTTP_HOST"] );
$site_id = cjoverkill_site_discover ( $site_dom );

// global variables before filter

$in_php = 1;
$out_php = 0;

$stime = localtime ();
$thishour = $stime[2];

$referer = cjoverkill_sanityze ( $_SERVER["HTTP_REFERER"] );
$ref = $referer;

if ( $_SERVER["HTTP_X_FORWARDED_FOR"] ) {
    $proxy = cjoverkill_sanityze ( cjoverkill_ip_normalize ( $_SERVER["REMOTE_ADDR"] ) );
    $ip = cjoverkill_sanityze ( cjoverkill_ip_normalize ( $_SERVER["HTTP_X_FORWARDED_FOR"] ) );
    $filter_ip = $ip;
    $filter_ip_geo = $proxy;
} else {
    $ip = cjoverkill_sanityze ( cjoverkill_ip_normalize ( $_SERVER["REMOTE_ADDR"] ) );
    $proxy = "";
    $filter_ip = $ip;
    $filter_ip_geo = $filter_ip;
}

$tid = cjoverkill_sanityze ( $_GET["tid"] );
$td = cjoverkill_sanityze ( $_GET["td"] );

// Multipage site check done before filtering
// Disable fast load filter for in.php if multipage site.
$multipass = 1;
$sql = mysqli_query ( $cjoverkill_link, "SELECT site_multipage, site_incookie, site_domain FROM cjoverkill_sites WHERE site_id='$site_id'" ) OR cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
$tmp = @mysqli_fetch_array ( $sql );
extract ( $tmp );
if ( $site_multipage == 1 ) {
    if ( $_COOKIE["cjoverkill_in"] < time () - $site_incookie ) {
        setcookie ( "cjoverkill_in", time (), time () + ($site_incookie * 1) );
    } else {
        setcookie ( "cjoverkill_in", time (), time () + ($site_incookie * 1) );
        $multipass = 0;
    }
}

// Disable in.php tracking if the in comes from the same domain
if ( $referer != "" && $referer != "-" ) {
    $tmp = parse_url ( $referer );
    $tmp["host"] = strtolower ( $tmp["host"] );
    $tmp_domain = preg_replace ( "/^www\./", "", $tmp["host"] );
    if ( $tmp_domain == $site_domain ) {
        $multipass = 0;
    }
}

include ("cj-filter.php");

if ( $filter_rampage == 0 && $multipass == 1 ) {

    //global variables set

    $c2code = $country_code;
    //reset if proceeds

    $sql = @mysqli_query ( $cjoverkill_link, "SELECT * FROM cjoverkill_reset WHERE site_id='$site_id'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    $tmp = @mysqli_fetch_array ( $sql );
    extract ( $tmp );
    $sql = @mysqli_query ( $cjoverkill_link, "SELECT log_prune, net_rst_d FROM cjoverkill_network_settings" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    $tmp = @mysqli_fetch_array ( $sql );
    extract ( $tmp );
    $time_tmp = time ();
    // Check if resets are correct and fix if needed
    if ( $rst_h >= ($time_tmp + 7200) ) {
        $warnlevel = 22;
        $warnmsg = "FIXED reset timer in the future for this site. Check webserver clock.";
        @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_reset SET rst_h='0', rst_d='0', rst_log='0'" ) OR cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
        cjoverkill_warn_log ( $warnmsg, $warnlevel );
        $rst_h = 0;
        $rst_d = 0;
        $rst_log = 0;
    }
    if ( $net_rst_d >= ($time_tmp + 1728000) ) {
        $warnlevel = 22;
        $warnmsg = "FIXED reset timer in the future for the global network. Check webserver clock.";
        @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_network_settings SET net_rst_d='0'" ) OR cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
        cjoverkill_warn_log ( $warnmsg, $warnlevel );
        $net_rst_d = 0;
    }
    // Do the resets
    if ( $time_tmp >= $net_rst_d ) {
        cjoverkill_dalyglobal ();
    }
    if ( $time_tmp >= $rst_d ) {
        cjoverkill_daily ( $site_id );
    }
    if ( $time_tmp >= $rst_h ) {
        cjoverkill_hourly ( $site_id );
        cjoverkill_cheats ( $site_id );
        if ( $site_id != 1 ) {
            cjoverkill_toplist ( $site_id );
        }
    }
    if ( $time_tmp >= $rst_log && $log_prune != 0 ) {
        cjoverkill_logprune ( $site_id, $log_prune );
    }

    $fprocess = 0;

    //credit the trade that sends the surfer
    // Stage 1 --> By Trade ID

    if ( isset ( $tid ) && $tid != "" ) {
        $sql = @mysqli_query ( $cjoverkill_link, "SELECT old_id, trade_id, vtrade_id FROM cjoverkill_trades WHERE old_id='$tid' AND old_id!='0' AND site_id='$site_id'" ) OR
                cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
        if ( mysqli_num_rows ( $sql ) <= 0 ) {
            $sql = @mysqli_query ( $cjoverkill_link, "SELECT trade_id, vtrade_id FROM cjoverkill_trades WHERE trade_id='$tid' AND site_id='$site_id'" ) OR
                    cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
            if ( mysqli_num_rows ( $sql ) <= 0 ) {
                $vtid = 2;
                $tid = cjoverkill_trade_discover ( $vtid, $site_id );
            }
        }
        $trade_id = $tid;
        if ( $referer == "" || $referer == "-" ) {
            $referer = "bookmarks";
            $ref = "no refering url";
        }
    }

    // Stage 2 --> By trade domain
    elseif ( isset ( $td ) && $td != "" ) {
        /* if (strlen($td)>$strlen_max){
          $what="td domain too long, possible overflow attack";
          @mysqli_query($cjoverkill_link, "INSERT INTO cjoverkill_security (fecha, what, ip, proxy, hour)
          VALUES (NOW(), '$what', '$ip', '$proxy', '$thishour')") OR
          cjoverkill_db_error(mysqli_error($cjoverkill_link));
          } */
        $sql = @mysqli_query ( $cjoverkill_link, "SELECT trade_id, vtrade_id FROM cjoverkill_trades WHERE domain='$td' AND site_id='$site_id'" ) OR
                cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
        if ( mysqli_num_rows ( $sql ) <= 0 ) {
            $vtid = 2;
            $trade_id = cjoverkill_trade_discover ( $vtid, $site_id );
            $tid = $trade_id;
        } else {
            /*
              $tmp=@mysqli_fetch_array($sql);
              extract($tmp);
              $tid=$trade_id;
             */
        }
        if ( $referer == "" || $referer == "-" ) {
            $referer = "bookmarks";
            $ref = "no refering url";
        }
    }

    // Stage 3 --> By referrer. This method is old, but still widely used.
    else {
        if ( $referer != "" && $referer != "-" ) {
            /* if (strlen($referer)>$strlen_max){
              $what="Referer string too long, possible overflow attack";
              @mysqli_query($cjoverkill_link, "INSERT INTO cjoverkill_security (fecha, what, ip, proxy, hour)
              VALUES (NOW(), '$what', '$ip', '$proxy', '$thishour')") OR
              cjoverkill_db_error(mysqli_error($cjoverkill_link));
              cjoverkill_print_error("Security violation attempt detected!<BR>
              IP=$ip<BR>
              Proxy=$proxy<BR>
              are you trying to hack me duhdah?
              ");
              } */
            $tmp = parse_url ( $referer );
            $tmp["host"] = strtolower ( $tmp["host"] );
            $domain = preg_replace ( "/^www\./", "", $tmp["host"] );
            if ( $domain != "" ) {
                $referer = $domain;
            } else {
                $referer = "bookmarks";
                $ref = "no refering url";
            }
        } else {
            $referer = "bookmarks";
            $ref = "no refering url";
        }
        $sql = @mysqli_query ( $cjoverkill_link, "SELECT trade_id, vtrade_id FROM cjoverkill_trades WHERE domain='$referer' AND site_id='$site_id'" ) OR
                cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    }
    if ( @mysqli_num_rows ( $sql ) == 0 && (!isset ( $vtid ) || $vtid == "") && $referer == "" ) {
        $vtrade_id = 1;
        $trade_id = cjoverkill_trade_discover ( $vtrade_id, $site_id );
    } elseif ( @mysqli_num_rows ( $sql ) == 0 && (!isset ( $vtid ) || $vtid == "") && $referer != "" ) {
        $vtrade_id = 2;
        $trade_id = cjoverkill_trade_discover ( $vtrade_id, $site_id );
    } else {
        if ( $vtrade_id != 2 && $vtid != 2 ) {
            $tmp = @mysqli_fetch_array ( $sql );
            extract ( $tmp );
        }
    }


    // ref log
    @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_ref_$site_id SET raw_in=raw_in+1 WHERE trade_id='$trade_id' AND referer='$ref'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    if ( @mysqli_affected_rows ( $cjoverkill_link ) == 0 ) {
        @mysqli_query ( $cjoverkill_link, "INSERT INTO cjoverkill_ref_$site_id (trade_id, referer, raw_in, hour)
      VALUES ('$trade_id', '$ref', '1', '$thishour')" ) OR
                cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    }

    // IP log + Country Log + Trade track
    $israw = 0;
    @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_iplog_in_$site_id SET raw_in=raw_in+1, cstamp='$timestamp' WHERE ip='$ip' AND
			proxy='$proxy' AND 
			trade_id='$trade_id' AND 
			site_id='$site_id'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    if ( @mysqli_affected_rows ( $cjoverkill_link ) == 0 ) {
        $israw = 0;
        @mysqli_query ( $cjoverkill_link, "INSERT INTO cjoverkill_iplog_in_$site_id (site_id, trade_id, ip, proxy, raw_in, hour, cstamp)
      VALUES ('$site_id', $trade_id, '$ip', '$proxy', '1', '$thishour', '$timestamp')" ) OR
                cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
        @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_stats SET raw_in$thishour=raw_in$thishour+1, uniq_in$thishour=uniq_in$thishour+1
		   WHERE trade_id='$trade_id' AND site_id='$site_id'" ) OR
                cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
        @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_trades SET raw_tot=raw_tot+1, uniq_tot=uniq_tot+1, last_visit=NOW() WHERE trade_id='$trade_id' AND site_id='$site_id'" ) OR
                cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
        /* @mysqli_query($cjoverkill_link, "INSERT INTO cjoverkill_country_log_in (site_id, trade_id, c2code, uniqs, raws)
          VALUES ('$site_id', '$trade_id', '$c2code', '1', '1')") OR
          cjoverkill_db_error(mysqli_error($cjoverkill_link)); */
    } else {
        $israw = 1;
        @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_stats SET raw_in$thishour=raw_in$thishour+1 WHERE trade_id='$trade_id' AND site_id='$site_id'" ) OR
                cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
        @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_trades SET raw_tot=raw_tot+1 WHERE trade_id='$trade_id' AND site_id='$site_id'" ) OR
                cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
        /* @mysqli_query($cjoverkill_link, "UPDATE cjoverkill_country_log_in SET raws=raws+1 WHERE trade_id='$trade_id'") OR
          cjoverkill_db_error(mysqli_error($cjoverkill_link)); */
    }

    if ( $israw == 1 ) {
        @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_country_log_in SET raws=raws+1 WHERE trade_id='$trade_id' AND c2code='$c2code' AND site_id='$site_id'" ) OR
                cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
        if ( @mysqli_affected_rows ( $cjoverkill_link ) == 0 ) {
            @mysqli_query ( $cjoverkill_link, "INSERT INTO cjoverkill_country_log_in (site_id, trade_id, c2code, uniqs, raws)
	  VALUES ('$site_id', '$trade_id', '$c2code', '1', '1')" ) OR
                    cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
        }
    } else {
        @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_country_log_in SET raws=raws+1, uniqs=uniqs+1 WHERE
		   trade_id='$trade_id' AND c2code='$c2code' AND site_id='$site_id'" ) OR
                cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
        if ( @mysqli_affected_rows ( $cjoverkill_link ) == 0 ) {
            @mysqli_query ( $cjoverkill_link, "INSERT INTO cjoverkill_country_log_in (site_id, trade_id, c2code, uniqs, raws)
	  VALUES ('$site_id', '$trade_id', '$c2code', '1', '1')" ) OR
                    cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
        }
    }



    // Check for max_clicks and max_ip and filter if needed
    // Check for max_ip
    $sql = @mysqli_query ( $cjoverkill_link, "SELECT ip_enable, clicks_enable FROM cjoverkill_sites WHERE site_id='$site_id'" ) OR
            cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
    $tmp = @mysqli_fetch_array ( $sql );
    extract ( $tmp );
    if ( $ip_enable >= "1" && $whitelisted != 1 ) {
        $sql = @mysqli_query ( $cjoverkill_link, "SELECT COUNT(*) AS cnt_ip FROM cjoverkill_iplog_in_$site_id, cjoverkill_trades WHERE
			cjoverkill_iplog_in_$site_id.trade_id='$trade_id' AND
			cjoverkill_iplog_in_$site_id.trade_id=cjoverkill_trades.trade_id AND
			cjoverkill_iplog_in_$site_id.raw_in>cjoverkill_trades.max_ip AND
			cjoverkill_iplog_in_$site_id.ip='$ip'" ) OR
                cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
        /* cjoverkill_db_error(mysqli_error($cjoverkill_link)); */
        $tmp = @mysqli_fetch_array ( $sql );
        extract ( $tmp );
        if ( $cnt_ip >= 1 && $fprocess == 0 ) {
            // Get other data
            $sql = @mysqli_query ( $cjoverkill_link, "SELECT raw_in AS fraw_in, clicks AS fclicks, hour AS fhour FROM cjoverkill_iplog_in_$site_id, cjoverkill_trades WHERE
			cjoverkill_iplog_in_$site_id.trade_id='$trade_id' AND
			cjoverkill_iplog_in_$site_id.trade_id=cjoverkill_trades.trade_id AND
			cjoverkill_iplog_in_$site_id.ip='$ip'" ) OR
                    cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
            $tmp = @mysqli_fetch_array ( $sql );
            extract ( $tmp );
            // bann IP
            $reason = "Maximum repetitive visits count exceeded for this IP. Possible hitbot";
            @mysqli_query ( $cjoverkill_link, "INSERT INTO cjoverkill_filter_ip (site_id, ip_from, ip_to, reason, hour, auto) VALUES
		       ('$site_id', '$ip', '$ip', '$reason', '$thishour', '1')" ) OR
                    cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
            // get ftrade_id
            $ftrade_id = cjoverkill_trade_discover ( 5, $site_id );
            if ( $ftrade_id != $trade_id ) {
                // substract from stats and trade and add them to the filter trade
                @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_stats SET raw_in$thishour=raw_in$thishour-$fraw_in, uniq_in$thishour=uniq_in$thishour-1,
    					clicks$fhour=clicks$fhour-$fclicks
    				WHERE trade_id='$trade_id' AND site_id='$site_id'" ) OR
                        cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
                @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_stats SET raw_in$thishour=raw_in$thishour+$fraw_in, uniq_in$thishour=uniq_in$thishour+1,
    				clicks$fhour=clicks$fhour+$fclicks
    				WHERE trade_id='$ftrade_id' AND site_id='$site_id'" ) OR
                        cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
                @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_trades SET raw_tot=raw_tot-$fraw_in, uniq_tot=uniq_tot-1, clicks_tot=clicks_tot-$fclicks WHERE
    					trade_id='$trade_id' AND site_id='$site_id'" ) OR
                        cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
                @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_trades SET raw_tot=raw_tot+$fraw_in, uniq_tot=uniq_tot+1, clicks_tot=clicks_tot+$fclicks WHERE
    					trade_id='$ftrade_id' AND site_id='$site_id'" ) OR
                        cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
                // update IP log_in with the correct trade ID for that IP
                @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_iplog_in_$site_id SET trade_id='$ftrade_id', ftrade_id='$trade_id' WHERE
    					ip='$ip' AND proxy='$proxy' AND trade_id='$trade_id' AND site_id='$site_id'" ) OR
                        cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
            }

            $fprocess = 1;
        }
    }
    // Check for max_clicks
    if ( $clicks_enable >= "1" && $whitelisted != 1 ) {
        $sql = @mysqli_query ( $cjoverkill_link, "SELECT COUNT(*) AS cnt_clicks FROM cjoverkill_iplog_in_$site_id, cjoverkill_trades WHERE
			cjoverkill_iplog_in_$site_id.trade_id='$tid' AND
			cjoverkill_iplog_in_$site_id.trade_id=cjoverkill_trades.trade_id AND
			cjoverkill_iplog_in_$site_id.clicks>cjoverkill_trades.max_clicks AND
			cjoverkill_iplog_in_$site_id.ip='$ip'" ) OR
                cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
        /* 	$sql=@mysqli_query($cjoverkill_link, $ssql) OR
          cjoverkill_db_error(mysqli_error($cjoverkill_link)); */
        $tmp = @mysqli_fetch_array ( $sql );
        extract ( $tmp );
        if ( $cnt_clicks >= 1 && $fprocess == 0 ) {
            // Get other data
            $sql = @mysqli_query ( $cjoverkill_link, "SELECT raw_in AS fraw_in, clicks AS fclicks, hour AS fhour FROM cjoverkill_iplog_in_$site_id, cjoverkill_trades WHERE
			cjoverkill_iplog_in_$site_id.trade_id='$trade_id' AND
			cjoverkill_iplog_in_$site_id.trade_id=cjoverkill_trades.trade_id AND
			cjoverkill_iplog_in_$site_id.ip='$ip'" ) OR
                    cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
            $tmp = @mysqli_fetch_array ( $sql );
            extract ( $tmp );
            // bann IP
            $reason = "Maximum clicks count exceeded for this IP. Possible hitbot";
            @mysqli_query ( $cjoverkill_link, "INSERT INTO cjoverkill_filter_ip (site_id, ip_from, ip_to, reason, hour, auto) VALUES
		       ('$site_id', '$ip', '$ip', '$reason', '$thishour', '1')" ) OR
                    cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
            // get ftrade_id
            $ftrade_id = cjoverkill_trade_discover ( 5, $site_id );
            if ( $ftrade_id != $trade_id ) {
                // substract from stats and trade and add them to the filter trade
                @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_stats SET raw_in$thishour=raw_in$thishour-$fraw_in, uniq_in$thishour=uniq_in$thishour-1,
    					clicks$fhour=clicks$fhour-$fclicks
    				WHERE trade_id='$trade_id' AND site_id='$site_id'" ) OR
                        cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
                @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_stats SET raw_in$thishour=raw_in$thishour+$fraw_in, uniq_in$thishour=uniq_in$thishour+1,
    				clicks$fhour=clicks$fhour+$fclicks
    				WHERE trade_id='$ftrade_id' AND site_id='$site_id'" ) OR
                        cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
                @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_trades SET raw_tot=raw_tot-$fraw_in, uniq_tot=uniq_tot-1, clicks_tot=clicks_tot-$fclicks WHERE
    					trade_id='$trade_id' AND site_id='$site_id'" ) OR
                        cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
                @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_trades SET raw_tot=raw_tot+$fraw_in, uniq_tot=uniq_tot+1, clicks_tot=clicks_tot+$fclicks WHERE
    					trade_id='$ftrade_id' AND site_id='$site_id'" ) OR
                        cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
                // update IP log_in with the correct trade ID for that IP
                @mysqli_query ( $cjoverkill_link, "UPDATE cjoverkill_iplog_in_$site_id SET trade_id='$ftrade_id', ftrade_id='$trade_id' WHERE
    					ip='$ip' AND proxy='$proxy' AND trade_id='$trade_id' AND site_id='$site_id'" ) OR
                        cjoverkill_db_error ( mysqli_error ( $cjoverkill_link ) );
            }

            $fprocess = 1;
        }
    }
}
cjoverkill_disconnect ();

?>
